<?php
/**
 * Контроллер: Payment
 *
 * Класс Controllers_Payment предназначен для приема и обработки платежей.
 * @package moguta.cms
 * @subpackage Controller
 */
class Controllers_Payment extends BaseController {
    
  public $msg = "";
  function __construct() {
    $this->msg = "";
    $paymentID = $_GET['id'];
    $paymentStatus = $_GET['pay'];
    $_POST['url'] = URL::getUrl();
    $modelOrder = new Models_Order();
    if (!$paymentID) {
      $paymentID = $_REQUEST['id'];
    }    
    if (!$paymentStatus) {
      $paymentStatus = $_REQUEST['pay'];
    }
    if(isset($_GET['getQr'])){
      $this::getQr($_GET['getQr']);
    }  
     //MG::loger($_REQUEST);
    $msg = '';
    switch ($paymentID) {


    }

    $this->data = array(
      'payment' => $paymentID, //id способа оплаты
      'status' => $paymentStatus, //статус ответа платежной системы (result, success, fail)
      'message' => $msg, //статус ответа платежной системы (result, success, fail)
    );
  }

  /**
   * Действие при оплате заказа.
   * Обновляет статус заказа на Оплачен, отправляет письма оповещения, генерирует хук.
   * @param array $args массив с результатом оплаты
   * @return array
   */
  public function actionWhenPayment($args) {
    $result = true;
    ob_start();
    $order = new Models_Order();

    if(method_exists($order, 'updateOrder')) {
      $order->updateOrder(array('id' => $args['paymentOrderId'], 'status_id' => 2, 'paided' => 1));
    }
    if(method_exists($order, 'sendMailOfPayed')) {
      $order->sendMailOfPayed($args['paymentOrderId'], $args['paymentAmount'], $args['paymentID']);
    }
    if(method_exists($order, 'sendLinkForElectro')) {
      $order->sendLinkForElectro($args['paymentOrderId']);
    }

    $content = ob_get_contents();
    ob_end_clean();

    // если в ходе работы метода допущен вывод контента, то записать в лог ошибку.
    if(!empty($content)) {
      MG::loger('ERROR PAYMENT: ' . $content);
    }

    return MG::createHook(__CLASS__ . "_" . __FUNCTION__, $result, $args);
  }




  /**
   * Проверка платежа через PayKeeper.
   */
  public function paykeeper($paymentID, $paymentStatus) {
    $order = new Models_Order();
  
    if('success' == $paymentStatus) {
      
      if(!empty($_POST['clientid'])) {
        $orderInfo = $order->getOrder(" id = " . DB::quoteInt(intval($_POST['clientid']), 1));
        $msg = 'Вы успешно оплатили заказ № ' . $orderInfo[$_POST['clientid']]['number'].'. Спасибо! Ожидайте звонка менеджера.'; 
      } else {
        $msg = 'Вы успешно оплатили заказ. Спасибо! Ожидайте звонка менеджера.';
      }  
      $msg .= $this->msg;
      
    } elseif('result' == $paymentStatus && count($_POST) > 1) {
      
      $id = $_POST['id'];
      $paymentAmount = $_POST['sum'];
      $paymentOrderId = intval($_POST['clientid']);
      $orderid = $_POST['orderid'];
      $key = $_POST['key'];
        
      //Проверка существование заказа и подлинности платежа
      if(!empty($paymentAmount) && $paymentOrderId > 0) {
        $orderInfo = $order->getOrder(" id = " . DB::quoteInt($paymentOrderId, 1) . " and summ+delivery_cost = " . DB::quoteFloat($paymentAmount));
      }

      $paymentInfo = $order->getParamArray($paymentID);
      $secret_seed = trim($paymentInfo[2]['value']);

      if($key != md5 ($id . sprintf ("%.2lf", $paymentAmount).$paymentOrderId.$orderid.$secret_seed)) {
        echo "Error! Hash mismatch";
        exit();
      }
      
      // предварительная проверка платежа
      if(empty($orderInfo)) {
        echo "ERR: НЕКОРРЕКТНЫЕ ДАННЫЕ ЗАКАЗА";
        exit();
      }
      if (!$orderInfo[$paymentOrderId]['paided']) {
        $this->actionWhenPayment(
          array(
            'paymentOrderId' => $paymentOrderId,
            'paymentAmount' => $paymentAmount,
            'paymentID' => $paymentID
          )
        );
      }
      
      // ОТДАЕМ PAYKEEPER ВСЕ OK
      echo "OK ".md5($id.$secret_seed);
      exit;
    } else {
      $msg = 'Оплата не удалась';
    }
    
    return $msg;
  }

  /**
   * Проверка платежа через CloudPayments.
   * @param int $paymentID ID способа оплаты
   * @param string $paymentStatus статус платежа
   * @return string
   */
  public function cloudpayments($paymentID, $paymentStatus) {
  
    $orderNumber = URL::getQueryParametr('orderNumber');

 //   if (empty($orderNumber)) {
 //     echo 'Оплата не удалась';
 //     exit();
 //   }

    // Редирект из виджета
    if($paymentStatus == 'success') {
      $msg = str_replace('{number}', $orderNumber, lang('paymentCloudPaymentsSuccess'));
      $msg .= $this->msg;
      return $msg;
    } elseif($paymentStatus == 'fail') {
      $msg = str_replace('{number}', $orderNumber, lang('paymentCloudPaymentsFail'));
      $msg .= $this->msg;
      return $msg;
    }

    // Обрабатываем уведомление от CloudPayments
    $response_codes = array(
      'SUCCESS' => 0,
      'ERROR_INVALID_ORDER' => 10,
      'ERROR_INVALID_COST' => 11,
      'ERROR_NOT_ACCEPTED' => 13,
      'ERROR_EXPIRED' => 20
    );

    $response = array(
      'code' => $response_codes['SUCCESS']
    );

    $order = new Models_Order();
    $paymentInfo = $order->getParamArray($paymentID, null, null);
    // Проверяем контрольную подпись
    $post_data    = file_get_contents('php://input');
    $check_sign   = base64_encode(hash_hmac('SHA256', $post_data, $paymentInfo[1]['value'], true));
    $request_sign = isset($_SERVER['HTTP_CONTENT_HMAC']) ? $_SERVER['HTTP_CONTENT_HMAC'] : '';


    if(false && $check_sign !== $request_sign) {
      $response['code'] = $response_codes['ERROR_NOT_ACCEPTED'];
      $response['msg'] = 'Invalid signature';
    } else {
      $action = URL::getQueryParametr('action');
      $orderId = null;
      if(isset($_POST['Data'])) {
        $data = json_decode(str_replace('&quot;', '"', $_POST['Data']), true);
        if(!empty($data['order_id'])) {
          $orderId = intval($data['order_id']);
        }
      }
      if(!empty($orderId)) {
        $orderInfo = $order->getOrder(" id = " . DB::quoteInt($orderId, 1));
        $orderInfo = current($orderInfo);
      } else {
        $orderNumber = isset($_POST['InvoiceId']) ? $_POST['InvoiceId'] : '';
        $orderInfo = $order->getOrder(" number = " . DB::quote($orderNumber));
        $orderInfo = current($orderInfo);
        $orderId = isset($orderInfo['id']) ? $orderInfo['id'] : null;
      }
      if(empty($orderInfo)) {
        $response['code'] = $response_codes['ERROR_INVALID_ORDER'];
        $response['msg'] = 'Order not found';
      } else {
        // Запросы связанные с оплатой, для них проверяем статус заказа и сумму
        $is_payment_callback = in_array($action, array('check', 'pay', 'confirm'));
        $orderSum = floatval($orderInfo['summ']) + floatval($orderInfo['delivery_cost']);

        if($is_payment_callback && in_array($orderInfo['status_id'], array(2, 4, 5))) {
          // Нельзя оплатить уже оплаченный заказ
          $response['code'] = $response_codes['ERROR_NOT_ACCEPTED'];
          $response['msg'] = 'Order already payment or canceled';
        } 
        elseif($is_payment_callback && floatval($_POST['Amount']) != $orderSum) {
          // Проверяем сумму заказа
          $response['code'] = $response_codes['ERROR_INVALID_COST'];
          $response['msg'] = 'Invalid order summ, should be ' . $orderSum;
        } 
        elseif(($action == 'pay' && $_POST['Status'] == 'Completed') || $action == 'confirm') {
          $this->actionWhenPayment(
            array(
              'paymentOrderId' => $orderId,
              'paymentAmount' => $orderInfo['summ'],
              'paymentID' => $paymentID
            )
          );
        }
        elseif(in_array($action, array('fail', 'cancel'))) {
          $order = new Models_Order();
          if(method_exists($order, 'updateOrder')) {
            $order->updateOrder(array(
              'id' => $orderId,
              'status_id' => 0
            ), true);
          }
        }
        elseif(in_array($action, array('refund'))) {
          $order = new Models_Order();
          if(method_exists($order, 'updateOrder')) {
            $order->updateOrder(array(
              'id' => $orderId,
              'status_id' => 4
            ), true);
          }
        }
        elseif(in_array($action, array('pay')) && $_POST['Status'] == 'Authorized') {
          $order = new Models_Order();
          if(method_exists($order, 'updateOrder')) {
            $order->updateOrder(array(
              'id' => $orderId,
              'status_id' => 1
            ), true);
          }
        }
      }
    }

    header('Content-Type: application/json');
    echo json_encode($response, 256); //JSON_UNESCAPED_UNICODE для совместимости с PHP 5.3;
    exit;
  }

  /**
   * Проверка платежа через Яндекс.Кассу.
   * @param int $paymentID ID способа оплаты
   */
  public function yandexKassaNew($paymentID) {

    /* Узнаем статус
      waiting_for_capture
      succeeded
      canceled
    */

    $data = file_get_contents("php://input");
    $json = json_decode($data, true);
    
    $paymentStatus = $json['object']['status'];
    $orderId = $json['object']['metadata']['orderId'];
    $orderSessionId = $json['object']['metadata']['sessionId'];
    $orderPayTime = $json['object']['metadata']['payTime'];

    $sess_path = session_save_path();
    //флаг платежа
    $payFlag = true;
    //Проверка платежа по сессии
    if ($handle = opendir($sess_path)) {
        while (false !== ($entry = readdir($handle))) { 
            $file = $sess_path.DS.$entry;
            if(stripos($file, $orderSessionId) !== false){
                $sessionContent = file_get_contents($file);
                session_decode($sessionContent);
                if($_SESSION['pay_time'] != $orderPayTime){
                    $payFlag = false;
                }
            }
        }       
    }    

    if ((empty($orderId)) || (($payFlag == false))) {
      echo 'Оплата не удалась';
      exit();
    }
    //Массив статусов, которые могут быть изменены
    $orderStatusChangeArray = array(0, 1);
    $order = new Models_Order();
    $orderInfo = $order->getOrder(' id = '.DB::quoteInt(intval($orderId), true));
    $orderNumber = $orderInfo[$orderId]['number'];    
    if($paymentStatus == 'succeeded' || $paymentStatus == 'waiting_for_capture') {
      //$orderInfo = $order->getOrder(" number = " . DB::quote($orderNumber));
      if(in_array($orderInfo[$orderId]['status_id'], $orderStatusChangeArray)){
        $this->actionWhenPayment(
          array(
            'paymentOrderId' => $orderId,
            'paymentAmount' => $orderInfo[$orderId]['summ'],
            'paymentID' => $paymentID
            )
          );
      }
      $msg = 'Вы успешно оплатили заказ №' . $orderNumber;
      $msg .= $this->msg;
      $this->msg = $msg;
    } elseif($paymentStatus == 'canceled') {
      //Нужно ли менять статус у заказа  
      if(in_array($orderInfo[$orderId]['status_id'], $orderStatusChangeArray) && (defined('CHANGE_STATUS_UKASSA')) &&  CHANGE_STATUS_UKASSA == 1){
      $order->setOrderStatus($orderId, 4);
      }
      $msg = "Оплата заказ №" . $orderNumber . " не удаласть\n";
      $msg .= "Ошибка: ".$json['object']['cancellation_details']['reason'];
      $msg .= $this->msg;
      $this->msg = $msg;
    }  else {  
      //Раскоментировать, если будут проблемы
      //MG::loger($data, 'new', 'yandex');
      $this->msg = 'Оплата не удалась';
    }
    return $paymentStatus;
  }

  /**
   * Проверка платежа через FreeKassa.
   * @param int $paymentID ID способа оплаты
   * @param string $paymentStatus статус платежа
   */
  public function freeKassa($paymentID, $paymentStatus) {
    if('success' == $paymentStatus) {
      
      $msg = 'Вы успешно оплатили заказ. Спасибо!';
      
      $msg .= $this->msg;
      
    } elseif('fail' == $paymentStatus) {
      $msg = 'Не удалось оплатить заказ!';
      
      $msg .= $this->msg;
    } elseif('result' == $paymentStatus && !empty($_REQUEST['MERCHANT_ORDER_ID'])) {
      $orderAmount = $_REQUEST['AMOUNT']; //Стоимость заказа
      $orderId = $_REQUEST['MERCHANT_ORDER_ID']; //ID заказа

      if(empty($orderId)) {
        echo 'Оплата не удалась';
        exit();
      }

      //Получаем настройки оплаты
      $order = new Models_Order();
      $paymentInfo = $order->getParamArray($paymentID, null, null);

      //Получаем ID магазина и второе секретное слово
      $merchant_id = $paymentInfo[1]['value'];
      $merchant_secret = $paymentInfo[3]['value'];

      //Собираем подпись для проверки
      $sign = md5($merchant_id.':'.$orderAmount.':'.$merchant_secret.':'.$orderId);

      //Проверяем собранную подпись с пришедшей
      if ($sign != $_REQUEST['SIGN']) {
        //Если не совпало, то спамим в логер и прерываем выполнение
        MG::loger('Error pay free-kassa:');
        MG::loger($_REQUEST);
        die('wrong sign');
      }

      //Если подписи равны, то ищем заказ и помечаем его оплаченым
      $orderInfo = $order->getOrder(" id = " . DB::quoteInt($orderId));
     // if($orderInfo[$orderId]['status_id']!=2 && $orderInfo[$orderId]['status_id']!=4 && $orderInfo[$orderId]['status_id']!=5) {
      if($orderInfo[$orderId]['status_id'] == 0 || $orderInfo[$orderId]['status_id'] == 1 ) {  
        $this->actionWhenPayment(
          array(
            'paymentOrderId' => $orderId,
            'paymentAmount' => $orderAmount,
            'paymentID' => $paymentID
            )
          );
      }


      echo 'YES'; //Возвращаем 'YES' по документации FREE-KASSA
      exit();
    }
  }

  /**
   * Проверка платежа через Мегакасса.
   * @param int $paymentID ID способа оплаты
   * @param string $paymentStatus статус платежа
   */
  public function megaKassa($paymentID, $paymentStatus){
    if ($paymentStatus == 'success') {

      $msg = 'Вы успешно оплатили заказ. Спасибо!';

      $msg .= $this->msg;

    } elseif ($paymentStatus == 'fail') {
      $msg = 'Не удалось оплатить заказ!';

      $msg .= $this->msg;
    } elseif ($paymentStatus == 'result') {

      //Получаем настройки оплаты
      $order = new Models_Order();
      $paymentInfo = $order->getParamArray(27, null, null);
      $secretKey = $paymentInfo[1]['value'];

      $orderId = $_REQUEST['mg_order_id']; //ID заказа
      $orderAmount = $_REQUEST['amount']; //Стоимость заказа

      // проверка IP-адреса
      $ipChecked = false;

      foreach (array('HTTP_X_CLUSTER_CLIENT_IP', 'HTTP_X_FORWARDED_FOR', 'HTTP_X_FORWARDED', 'HTTP_FORWARDED_FOR', 'HTTP_FORWARDED', 'HTTP_CLIENT_IP', 'REMOTE_ADDR') as $param) {
        if (!empty($_SERVER[$param]) && $_SERVER[$param] === '5.196.121.217') {
          $ipChecked = true;
          break;
}
      }
      if (!$ipChecked) {
        die('error');
      }

      // проверка на наличие обязательных полей
      // поля $payment_time и $debug могут дать true для empty() поэтому их нет в проверке
      foreach (array('uid', 'amount', 'amount_shop', 'amount_client', 'currency', 'order_id', 'payment_method_title', 'creation_time', 'client_email', 'status', 'signature') as $field) {
        if (empty($_REQUEST[$field])) {
          die('error');
        }
      }

      // нормализация данных
      $uid = (int)$_REQUEST["uid"];
      $amount = (double)$_REQUEST["amount"];
      $amountShop = (double)$_REQUEST["amount_shop"];
      $amountClient = (double)$_REQUEST["amount_client"];
      $currency = $_REQUEST["currency"];
      $orderID = $_REQUEST["order_id"];
      $paymentMethodID = (int)$_REQUEST["payment_method_id"];
      $paymentMethodTitle = $_REQUEST["payment_method_title"];
      $creationTime = $_REQUEST["creation_time"];
      $paymentTime = $_REQUEST["payment_time"];
      $clientEmail = $_REQUEST["client_email"];
      $status = $_REQUEST["status"];
      $debug = (!empty($_REQUEST["debug"])) ? '1' : '0';
      $signature = $_REQUEST["signature"];

      // проверка валюты
      if (!in_array($currency, array('RUB', 'USD', 'EUR'), true)) {
        die('error');
      }

      // проверка статуса платежа
      if (!in_array($status, array('success', 'fail'), true)) {
        die('error');
      }

      // проверка формата сигнатуры
      if (!preg_match('/^[0-9a-f]{32}$/', $signature)) {
        die('error');
      }

      // проверка значения сигнатуры
      $signature_calc = md5(join(':', array($uid, $amount, $amountShop, $amountClient, $currency, $orderID, $paymentMethodID, $paymentMethodTitle, $creationTime, $paymentTime, $clientEmail, $status, $debug, $secretKey)));
      if ($signature_calc !== $signature) {
        die('error');
      }

      //Если подписи равны, то ищем заказ и помечаем его оплаченным
      $orderInfo = $order->getOrder(" id = " . DB::quoteInt($orderId));

      /*
      if($orderInfo[$orderId]['status_id']!=2 && $orderInfo[$orderId]['status_id']!=4 && $orderInfo[$orderId]['status_id']!=5 && $_REQUEST['status'] == 'success') {
        $this->actionWhenPayment(
          array(
            'paymentOrderId' => $orderId,
            'paymentAmount' => $orderAmount,
            'paymentID' => $paymentID
          )
        );
      }*/

      if($orderInfo[$orderId]['status_id'] == 0 || $orderInfo[$orderId]['status_id'] == 1 ) {  
        if($_REQUEST['status'] == 'success') {
          $this->actionWhenPayment(
            array(
              'paymentOrderId' => $orderId,
              'paymentAmount' => $orderAmount,
              'paymentID' => $paymentID
            )
          );
        }
      }
    

      echo('ok');
      exit();
    }
    return $msq;
  }

  /**
  * Проверка платежа через Qiwi API.
  * @param int $paymentID ID способа оплаты
  * @param string $paymentStatus статус платежа
  */
  public function qiwiApi($paymentID, $paymentStatus){
  //Получаем настройки оплаты
  $order = new Models_Order();
  $paymentInfo = $order->getParamArray(28, null, null);
  $secretKey = $paymentInfo[1]['value'];
  $orderIDqiwi = $_SESSION['qiwiApi']['orderID'];

  $auth = 'Bearer '. $secretKey;
  $url = 'https://api.qiwi.com/partner/bill/v1/bills/'.$orderIDqiwi;
  $curl = curl_init($url);
  curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
  curl_setopt($curl, CURLOPT_HTTPHEADER, array("Accept: application/json", "Content-Type: application/json", "Authorization: $auth"));

  $response = curl_exec($curl);
  $code = curl_getinfo($curl,CURLINFO_HTTP_CODE);
  curl_close($curl);

  $response = json_decode($response, true);
  $status = $response['status']['value'];
  if ($status == 'PAID') {
    $orderID = preg_replace('/-.*/is', '',$response['billId']);
    $orderInfo = $order->getOrder(" id = " . DB::quoteInt(intval($orderID), 1) . " and summ+delivery_cost = " . DB::quoteFloat($response['amount']['value']));

    if(empty($orderInfo)) {
          $msg = 'ERR: Заказ был изменен! Была произведена оплата '.$response['amount']['value'].' '.$response['amount']['currency'].'  по некорректному счету!';
          $msg .= $this->msg;
        }
    else{
    $msg = 'Вы успешно оплатили заказ. Спасибо!';
    $msg .= $this->msg;
      
    // Находим заказ и помечаем его оплаченным
    if ($response['billId'] == $orderIDqiwi) {
      $orderInfo = $order->getOrder(" id = " . DB::quoteInt($orderID));
      //if($orderInfo[$orderID]['status_id']!=2 && $orderInfo[$orderID]['status_id']!=4 && $orderInfo[$orderID]['status_id']!=5) {
      if($orderInfo[$orderID]['status_id'] == 0 || $orderInfo[$orderID]['status_id'] == 1 ) {  
        $this->actionWhenPayment(
          array(
            'paymentOrderId' => $orderID,
            'paymentAmount' => $response['amount']['value'],
            'paymentID' => $paymentID
          )
        );
       }
      }
    }
  } else {
  $msg = 'Возникла ошибка в оплате заказа.';
  $msg .= $this->msg;
  }

  return $msg;
  }
  
  /**
  * Проверка платежа через intellectMoney.
  * @param int $paymentID ID способа оплаты
  * @param string $paymentStatus статус платежа
  */
  public function intellectMoney($paymentID, $paymentStatus){
    $order = new Models_Order();
    if($_REQUEST['paymentStatus'] == 5 && isset($_REQUEST['UserField_1'])){
      $orderInfo = $order->getOrder(" id = " . DB::quoteInt($_REQUEST['UserField_1']));
      if($orderInfo[$_REQUEST['UserField_1']]['status_id'] == 0 || $orderInfo[$_REQUEST['UserField_1']]['status_id'] == 1){
        $msg = 'Вы успешно оплатили заказ. Спасибо!';
        $this->actionWhenPayment(
          array(
            'paymentOrderId' => $_REQUEST['UserField_1'],
            'paymentAmount' => $_REQUEST['recipientAmount'],
            'paymentID' => $_REQUEST['id']
            )
          );
      }
    }else if($_REQUEST['paymentStatus'] == 3){
      $msg = 'Создан счет на оплату';
    }else if($_REQUEST['paymentStatus'] == 4){
      $msg = 'Оплата не удалась';
    }
    return $msg;
  }

      /**
     * Проверка платежа через beGateway.
     * @param int $paymentID ID способа оплаты
     * @param string $paymentStatus статус платежа
     * @return string
     */
    public function beGateway($paymentID, $paymentStatus) {
      $msg = '';
      $order = new Models_Order();
      $orderId = $_REQUEST['order'];

      if ($paymentStatus == 'success') {

          if (isset($orderId)) {
              $orderInfo = $order->getOrder(" id = " . DB::quoteInt(intval($orderId), 1));
              $msg = 'Вы успешно оплатили заказ № ' . $orderInfo[$orderId]['number'] . '. Спасибо!';
          } else {
              $msg = 'Не указан номер заказа!';
          }

      } elseif ($paymentStatus == 'fail') {

          $msg = 'Не удалось оплатить заказ!';

      } elseif ($paymentStatus == 'result') {

          $paymentInfo = $order->getParamArray($paymentID, null, null);

          $rawbody = file_get_contents('php://input');

          $data = json_decode($rawbody, true);

          include_once CORE_LIB . 'BegatewayPayment.php';
          $api = new BegatewayPayment(
              $paymentInfo[0]['value'], // Shop ID
              $paymentInfo[1]['value'], // Shop Secret Key
              $paymentInfo[2]['value'], // Shop Public Key
              $paymentInfo[3]['value'], // Payment Domain
              $paymentInfo[4]['value'] // Test Mode
          );

          // Check request signature
          if ( !$api->isAuthorized() ) {
              $errorCode = 400;
              $errorMessage = 'Unauthorized Request';
              return $api->setError($errorCode, $errorMessage);
          }

          if (!isset($orderId) || !isset($data['transaction']['status'])) {
              $errorCode = 400;
              $errorMessage = 'Bad Request';
              return $api->setError($errorCode, $errorMessage);
          }

          $orderInfo = $order->getOrder(" id = " . DB::quoteInt(intval($orderId), 1));

          if (empty($orderInfo)) {
              $errorCode = 500;
              $errorMessage = 'Error: Заказа, с указанным идентификатором не существует в системе.';
              return $api->setError($errorCode, $errorMessage);
          }


          if($orderInfo[$orderId]['status_id'] == 0 || $orderInfo[$orderId]['status_id'] == 1 ) {

            if ($data['transaction']['status'] == 'successful') {
                $this->actionWhenPayment(
                    array(
                        'paymentOrderId' => $orderId,
                        'paymentAmount' => $orderInfo[$orderId]['summ'],
                        'paymentID' => $paymentID
                    )
                );
            }

         }

          return true;

      }

      $msg .= $this->msg;
      return $msg;
  }
  public static function getQr($orderId){
    require_once(REAL_DOCUMENT_ROOT.'/mg-core/script/phpqrcode/qrlib.php');
    $arr = unserialize(stripslashes(mg::getSetting('propertyOrder')));
    $order = new Models_Order();    
    $orderInfo = $order->getOrder(" id = " . DB::quoteInt(intval($orderId), 1));
    $site = str_replace('http://', '', SITE);
    $site = str_replace('https://', '', $site);
    $startPurposeQr = lang('startPurposeQr');
    $completePurposeQr = lang('completePurposeQr');
    if (EDITION === 'saas') {
      $startPurposeQr = CloudCoreBase::$CloudLocales->decryptionContentToRaw($startPurposeQr);
      $completePurposeQr = CloudCoreBase::$CloudLocales->decryptionContentToRaw($completePurposeQr);
    }
    $propertyOrder = 'ST00012|Name='.htmlspecialchars_decode($arr['nameyur']).
                      '|PersonalAcc='.$arr['rs'].
                      '|BankName='.htmlspecialchars_decode($arr['bank']).
                      '|BIC='.$arr['bik'].
                      '|CorrespAcc='.$arr['ks'].
                      '|PayeeINN='.$arr['inn'].
                      '|KPP='.$arr['kpp'].
                      '|Purpose='.$startPurposeQr.' № '.$orderInfo[$orderId]['number'].' '.$completePurposeQr.' '.$site.
                      '|Sum='.((MG::numberDeFormat($orderInfo[$orderId]['summ_shop_curr']) + MG::numberDeFormat($orderInfo[$orderId]['delivery_shop_curr'])) * 100).
                      '|TechCode=01';
    $access = false;
    if (USER::getThis()->login_email && (USER::getThis()->login_email == $orderInfo[$orderId]['user_email'] || USER::getThis()->role != 2)) {
      $access = true;
    }
    if (MG::getSetting('autoRegister') == "false") {
      $access = true;
    }
    if (!$access) {
      MG::redirect('/404');
      return false;
    }
    header('Content-Type: image/x-png');
    QRcode::png($propertyOrder, false, 'M', 6, 2);
  }
}
